/************************************************
  Team: Jon Gregory, Gor Nishanov
  Project #3
    for RPI course 66-648 Compiler Design Theory

  utils.h:

    List<T> template class 
    Hash<Key, Data> tempalte class //used by Identifier and Type classes
    Identifier class. 

  also this class contains

    QuickNew - the class providing custom allocation. All 
      small dynamically created classes descendands of this class.

      This allows us to destroy everything by using finalize() method.

    */  

extern int lineno;
char sabuf[32768];
int sabufuse;
class StringAllocator {
  int capacity;
  char* a;
  int avail;
public:
  //  StringAllocator(int n):capacity(n),a(new char[16384]),avail(0){
  //    assert(a);}
  //  ~StringAllocator(){--sabufuse; delete[] a;}
  StringAllocator(int n):capacity(n),a(sabuf),avail(0){
    assert(sabufuse == 0);
    ++sabufuse;
    assert(a);}
  ~StringAllocator(){--sabufuse;}
  char* newStr(int len) {
    assert((avail + len) <= capacity);
    avail += len;
    return a + avail - len; 
  }
  void clear(){avail = 0;}
};

struct QuickNew {
  static char * rawMemory;
  static char * actualEnd;
  static long Size() {return (unsigned)(actualEnd - rawMemory);}
  static long Avail() {return (unsigned)(end - avail);}
  static long Spent() {return Size() - Avail(); }
private:
  //  ~QuickNew(){ assert(false); }
  static char * avail;
  static char * end;
  static char * init(int size) {
    assert(rawMemory == 0 /* init could be called only once */ );
    rawMemory = (char*)new double[size * (1024/sizeof(double))];
    assert(rawMemory != 0 /* failed to allocate */ );
    memset(rawMemory, 0, size * 1024);
    avail = rawMemory;
    actualEnd = end   = avail + size * 1024;
    //    cout << "QuickNew::init = " << Size() << endl;
    return rawMemory;
  }
  //  void operator delete(void*)           { assert(false /* DON'T CALL ME */); }
  void operator delete(void*, size_t)   { assert(false /* DON'T CALL ME */); }
  void operator delete[](void*, size_t) { assert(false /* DON'T CALL ME */); }
  void* operator new[](size_t)          { assert(false /* DON'T CALL ME */); }

public:
  static void pad(int align) { // align should be a power of two
    avail = avail + ((avail-rawMemory + align-1)&~(align-1));
  }

  void * operator new(size_t size) {
    //          cout << "[new]";
    return bottomAlloc(size);
  }
  
  static char * topAlloc(size_t size) {
    //          cout << "tAlloc = " << size << endl;
    end -= size;
    assert(end > avail);
    return end;
  }
  
  static char * bottomAlloc(size_t size) {
    register char * result = avail;
    //          cout << "bAlloc = " << size << endl;
    avail += size;
    assert(avail <= end /* still in rawMemory */);
    return result;
  }
  
  static void finalize() {
    delete[] rawMemory;
  }
  virtual void qprint(ostream& o) const { o << "<QuickNew::qprint>"; }
  friend ostream& operator << (ostream& o, const QuickNew& n) {
    n.qprint(o); return o; }
  friend ostream& operator << (ostream& o, const QuickNew* n) {
    if(n) o << *n; else o << "<null>"; }
};

char * QuickNew::actualEnd = 0;
char * QuickNew::end = 0;
char * QuickNew::avail = 0;
char * QuickNew::rawMemory = QuickNew::init(LOCL_HEAP_SIZE);

template<class T>
class List : public QuickNew {
  //  List(List&){} // forbidden
public:
  T* first;
  T* last;
  int count;

  List():first(0),last(0),count(0){}
  explicit List(T* i):first(i),last(i),count(1){}
  int getSize() const {return count;}
  void add(T* i) { 
    ++count;
    if(first == 0) last = first = i;
              else last = (last->nextInOwner = i);
    last->nextInOwner = 0; // Just to be sure
  }
  void glueList(const List<T>* t){
    count += t->getSize();
    if(first == 0) last = first = t->first;
    else last->nextInOwner = t->first;
    last = t->last;
  }
  void clear() { first = last = 0; count = 0; }
  void print(ostream& o, char* sep = " ") const {
    T* f = first; int n = count;
    while(f != 0 && n--) {
      if(f != first) o << sep;
      o << f;
      f = f->nextInOwner;
    }
  };
  friend ostream& operator << (ostream& o, const List<T>& t){
    t.print(o); return o; }
  friend ostream& operator << (ostream& o, const List<T>* t){
    t->print(o); return o;}
};

template <class T,class D, int N>
class Hash {
  class bucket {
    bucket* next;
    friend Hash;
  public:
    T key;
    D data;
    bucket():key(T()),next(0),data(0){}
    bucket(T ky, bucket** prev, D dat ):
      key(ky),data(dat),next(0) {*prev = this;}
  };
  bucket hash[N];

public:
  bucket& get (T key, int len = 0) {
    unsigned int hno = (unsigned int)(key_hashNo(key, len) % N);
    bucket* bu = &hash[hno];
    if(key_empty(bu->key)) {
      bu->key = key;
      goto A; // It is bad, but code will be a little more efficient
    }
    for(;;) {
      if( key_equal(bu->key, key, len) ) break;
      if(bu->next == 0) {
        bu = (bu->next = (bucket*)QuickNew::bottomAlloc(sizeof(bucket)));
A:      bu->next = 0;
        bu->key = (T)key_make_new(key, len);
        break;
      }
      bu = bu->next;
    }
    return *bu;
  }
  void printSize() { cout << sizeof(hash); }
};

inline const char* key_make_new(const char* original, int len) {
  char* str = QuickNew::topAlloc(len+5)+4;
  assert(len <= 255);
  *(str - 1) = len;
  *(str - 2) = 0;
  memcpy(str, original, len);
  *(str - 3) = 0;
  *(str - 4) = 0;
  str[len] = 0;
  return str;
}

inline bool key_empty(const char* k) {return k == 0;}
inline bool key_equal(const char* a, const char* b, int len) {return strncmp(a,b,len) == 0; }
inline unsigned long key_hashNo(const char* a, int len) {
  unsigned long res = 0;
  while( len > 0 ) 
    res = ((res << 4) + a[--len] -'a'+1) % 98317l; // good prime number
  return res;
}

struct Nothing { Nothing(){} explicit Nothing(int){} };

struct IdentProxy { char* str_; }; // fighting yacc's union

class Identifier {
  char * str_;
  static Hash<char*, Nothing, NAME_HASH_SIZE> hash;

friend inline const Identifier key_make_new(const Identifier k,int) { return k; };
friend inline bool key_equal(const Identifier a, const Identifier b,int) 
  {return a.str_ == b.str_; }
friend inline bool key_empty(const Identifier k) {return k.str_ == 0;}
friend inline unsigned long key_hashNo(const Identifier i,int)
		{ return (unsigned long)(QuickNew::actualEnd - i.str_); }

public:
  static Identifier JavaLangObject;
  static Identifier JavaLangString;
  static Identifier JavaLangStringBuffer;
  static Identifier append;
  static Identifier toString, print, println;
  static Identifier JavaLangCloneable;
  static Identifier crazy, Code, ConstantValue;
  static Identifier self;
  static Identifier star, ctor, nullstr, clinit, length;

  void operator = (const IdentProxy a){str_ = a.str_;}
  Identifier(const IdentProxy a):str_(a.str_) {}
  Identifier(const Identifier& a):str_(a.str_){}
  operator IdentProxy() {IdentProxy tmp; tmp.str_ = str_; return tmp;}

  bool operator == (Identifier a) const {return a.str_ == str_;}
  Identifier():str_(0){}
  explicit Identifier(const char* str):str_(
    (str == 0)?nullstr.str_:hash.get((char*)str, strlen(str)).key){
//    cout << "id[" << QuickNew::actualEnd-str_ << "]=" << str_ << endl;
  }
  Identifier(const char* str, int len):str_(hash.get((char*)str, len).key){}

  Identifier(const char * a, const char * b) {
    char buf[1024];
    strcpy(buf, a);
    strcat(buf, b);
    str_ = hash.get(buf, strlen(buf)).key;
  }
  Identifier(Identifier a, char ch, Identifier b) {
    if(a.len() == 0) {str_ = b.str_; return; }
    char buf[1024];
    char* p = a.copyTo(buf);
    if(ch == 8) --p; else *p = ch;
    b.copyTo(p+1);
    str_ = hash.get(buf, a.len()+b.len()+1).key;
  }
  const char* asString() const {return str_;}
  int len() const {return *(str_-1);}
  u2 no() const {
    u2 cpool_no = (unsigned int)*(str_-3) + (unsigned int)*(str_-4)*256u;
    if(cpool_no == 0) {
      cpool_no = cpool.addUtf(str_);
      *(str_ - 3) = cpool_no & 255;
      *(str_ - 4) = cpool_no >> 8;
    }
    return cpool_no;
  }
  int id() const {return QuickNew::actualEnd - str_; }
  char* copyTo(char* a) const {memcpy(a, str_, len()+1); return a + len();}
  friend ostream& operator << (ostream& o, const Identifier i) {
    return o << i.asString(); }// << "'" << i.id(); }
};

Hash<char*, Nothing, NAME_HASH_SIZE> Identifier::hash;
Identifier Identifier::JavaLangObject("java/lang/Object");
Identifier Identifier::JavaLangString("java/lang/String");
Identifier Identifier::JavaLangStringBuffer("java/lang/StringBuffer");
Identifier Identifier::JavaLangCloneable("java/lang/Cloneable");
Identifier Identifier::append("append");
Identifier Identifier::toString("toString");
Identifier Identifier::println("println");
Identifier Identifier::print("print");
Identifier Identifier::star("*");
Identifier Identifier::ctor("<init>");
Identifier Identifier::clinit("<clinit>");
Identifier Identifier::nullstr("");
Identifier Identifier::crazy("!!! Crazy Ident !!!");
Identifier Identifier::length("length");
Identifier Identifier::self("this");
Identifier Identifier::Code("Code");
Identifier Identifier::ConstantValue("ConstantValue");

struct FileType { enum Enum {Error, Dir, File};  };

FileType::Enum getFileType(const char* path) {
  struct stat buf;
  if(stat(path, &buf)) return FileType::Error;
  if(buf.st_mode & S_IFDIR) return FileType::Dir;
  return FileType::File;
}

bool exists(const char* path) {
  struct stat buf;
  return !(stat(path, &buf)) ;
}

